#include <linux/module.h>
#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/signal.h>
#include <linux/errno.h>
#include <linux/signal.h>
#include <linux/sched.h>
#include <linux/timer.h>
#include <linux/tty.h>
#include <linux/serial.h>
#include <linux/interrupt.h>
#include <linux/string.h>
#include <linux/fcntl.h>
#include <linux/ptrace.h>

#include <asm/system.h>
#include <asm/io.h>
#include <asm/segment.h>
#include <asm/bitops.h>

extern unsigned long    loops_per_sec;

extern __inline__ void __delay(int loops)
{
  __asm__("\n1:\tdecl %0\n\tjns 1b\n": :"a" (loops):"ax");
}

extern int init_module() {
  
  int ticks;
  
  loops_per_sec = 1;

  printk("Calibrating delay loop.. ");
  while (loops_per_sec <<= 1) {
    ticks = jiffies;
    __delay(loops_per_sec);
    ticks = jiffies - ticks;
    if (ticks >= HZ) {
      __asm__("mull %1 ; divl %2"
	      :"=a" (loops_per_sec)
	      :"d" (HZ),
	      "r" (ticks),
	      "0" (loops_per_sec)
	      :"dx");
      printk("ok - %d.%02d BogoMips (tm)\n",
	     loops_per_sec/500000,
	     (loops_per_sec/5000) % 100);
      return 0;
    }
  }
  printk("failed\n");
}

extern void cleanup_module() {}
